import time
import threading
import traceback

from libraries.exceptions.auraexceptions import LQConnectionError


class LiquidSoapInitThread(threading.Thread):
    socket = None
    liquidsoapcommunicator = None

    def __init__(self, liquidsoapcommunicator, socket):
        threading.Thread.__init__(self)

        self.socket = socket
        self.liquidsoapcommunicator = liquidsoapcommunicator

    def run(self):
        try:
            # sleep needed, because the socket is created to slow by liquidsoap
            time.sleep(5)
            self.liquidsoapcommunicator.enable_transaction(True)

            # reset channels and reload them
            self.liquidsoapcommunicator.channels = None
            channels = self.liquidsoapcommunicator.get_all_channels()

            # set every volume to 0
            cnt = 0
            for c in channels:
                #self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "volume", cnt, "0")
                self.liquidsoapcommunicator.channel_volume(c, "0")
                cnt = cnt + 1

            # select all channels
            cnt = 0
            for c in channels:
                self.liquidsoapcommunicator.channel_activate(c)
                #self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "select", cnt, "true")
                cnt = cnt + 1

            # thats hacky => the cracklings stop after 5 seconds after restarting the liquidsoap server
            time.sleep(3)
            activechannel = self.liquidsoapcommunicator.get_active_channel()
            if self.liquidsoapcommunicator.debug > 2:
                print("LiquidSoapInitThread sets activechannel: "+str(activechannel))
            self.liquidsoapcommunicator.__send_lqc_command__(self.socket, "mixer", "volume", activechannel, 100)


#            self.liquidsoapcommunicator.close_conn(self.socket)
            self.liquidsoapcommunicator.disable_transaction(True)
        except LQConnectionError as e:
            print("Liquidsoap connection ERROR! Restart LQ Server!")
            print(e.message)
            print(e)
        except Exception as e:
            traceback.print_exc()
            print(e)


